#include "kinectpointsource.hpp"

#include <opencv/highgui.h>
//#include <opencv/highgui.hpp>

static KinectPointSource *kps = NULL;

extern "C" {
    void load_yml(const char *yml) {
        if(kps) {
            delete kps;
            kps = NULL;
        }
        
        kps = new KinectPointSource(yml);
    }
    
    void transform(void *p_rgb, void *p_depth, void *p_points, void *p_colors) {
        cv::Mat depth(480, 640, CV_16UC1, p_depth);
        cv::Mat rgb(480, 640, cv::Vec3b::type, p_rgb);
        
        cv::Mat ud_depth, ud_rgb;
        kps->remap_rgb(rgb, ud_rgb);
        kps->remap_depth(depth, ud_depth);
        
        std::vector<cv::Point3f> points;
        std::vector<cv::Vec3b> colors;
        kps->reproject(ud_rgb, ud_depth, points, colors);
        
        memcpy(p_points, &(points[0]), sizeof(cv::Point3f)*points.size());
        memcpy(p_colors, &(colors[0]), sizeof(cv::Vec3b)*colors.size());
    }
}

