#include <cv.h>
#include <cv.hpp>

#include <Eigen/Eigen>

template<class T>
class IndexView {
    private:
        T *data;
        int stride;
        
    public:
        IndexView(T* data, int stride)
            : data(data), stride(stride) {
        }
        
        T& operator()(int x, int y) {
            return data[y*stride + x];
        }
        
        const T& operator()(int x, int y) const {
            return data[y*stride + x];
        }
};

void calculate_normals(const float* p_points, int width, int height) {
    IndexView<cv::Point3f> points((cv::Point3f*)p_points, width);
    
    for(int y = 0; y < height; y++) {
        for(int x = 0; x < width; x++) {
            cv::Point3f &point = points(x, y);
            
        }
    }
}

